package com.ejie.ab79.service;
import com.ejie.ab79.dao.InspeccionesJsonDao;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.InspeccionesJson;

/**
 * InspeccionesJsonServiceImpl  
 *  
 */

@Service(value = "inspeccionesJsonService")
public class InspeccionesJsonServiceImpl implements InspeccionesJsonService {

	@Autowired
	private InspeccionesJsonDao inspeccionesJsonDao;

	/**
	 * Inserts a single row in the InspeccionesJson table.
	 *
	 * @param inspeccionesJson InspeccionesJson
	 * @return InspeccionesJson
	 */
	@Transactional(rollbackFor = Throwable.class)
	public InspeccionesJson add(InspeccionesJson inspeccionesJson) {
		return this.inspeccionesJsonDao.add(inspeccionesJson);
	}

	/**
	 * Updates a single row in the InspeccionesJson table.
	 *
	 * @param inspeccionesJson InspeccionesJson
	 * @return InspeccionesJson
	 */
	@Transactional(rollbackFor = Throwable.class)
	public InspeccionesJson update(InspeccionesJson inspeccionesJson) {
		return this.inspeccionesJsonDao.update(inspeccionesJson);
	 }

	/**
	 * Finds a single row in the InspeccionesJson table.
	 *
	 * @param inspeccionesJson InspeccionesJson
	 * @return InspeccionesJson
	 */
	public InspeccionesJson find(InspeccionesJson inspeccionesJson) {
		return (InspeccionesJson) this.inspeccionesJsonDao.find(inspeccionesJson);
	}
	
	/**
	 * Deletes a single row in the InspeccionesJson table.
	 *
	 * @param inspeccionesJson InspeccionesJson
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(InspeccionesJson inspeccionesJson) {
		this.inspeccionesJsonDao.remove(inspeccionesJson);
	}

	/**
	 * Finds a list of rows in the InspeccionesJson table.
	 *
	 * @param inspeccionesJson InspeccionesJson
	 * @param tableRequestDto TableRequestDto
	 * @return List<InspeccionesJson>
	 */
	public List<InspeccionesJson> findAll(InspeccionesJson inspeccionesJson, TableRequestDto tableRequestDto){
		return (List<InspeccionesJson>) this.inspeccionesJsonDao.findAll(inspeccionesJson, tableRequestDto);
	}
    
	/**
	 * Finds rows in the InspeccionesJson table using like.
	 *
	 * @param inspeccionesJson InspeccionesJson
	 * @param tableRequestDto TableRequestDto
     * @param startsWith Boolean	 
	 * @return List<InspeccionesJson>
	 */
	public List<InspeccionesJson> findAllLike(InspeccionesJson inspeccionesJson, TableRequestDto tableRequestDto, Boolean startsWith){
		return (List<InspeccionesJson>) this.inspeccionesJsonDao.findAllLike(inspeccionesJson, tableRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */
	 
	/**
	 * Removes rows from the InspeccionesJson table.
	 *
	 * @param filterInspeccionesJson InspeccionesJson
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith Boolean
	 */	
	public void removeMultiple(InspeccionesJson filterInspeccionesJson, TableRequestDto tableRequestDto,  Boolean startsWith){
		this.inspeccionesJsonDao.removeMultiple(filterInspeccionesJson, tableRequestDto, startsWith);
	}
        
	/**
	 * Filter method in the InspeccionesJson table.
	 *
	 * @param filterInspeccionesJson InspeccionesJson
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith Boolean
	 * @return TableResponseDto<InspeccionesJson>
	 */	
	public TableResponseDto< InspeccionesJson> filter(InspeccionesJson filterInspeccionesJson, TableRequestDto tableRequestDto,  Boolean startsWith){
		List<InspeccionesJson> listaInspeccionesJson =  this.inspeccionesJsonDao.findAllLike(filterInspeccionesJson, tableRequestDto, false);
		Long recordNum =  this.inspeccionesJsonDao.findAllLikeCount(filterInspeccionesJson != null ? filterInspeccionesJson: new InspeccionesJson (),false);
		
		TableResponseDto<InspeccionesJson> usuarioDto = new TableResponseDto<InspeccionesJson>(tableRequestDto, recordNum, listaInspeccionesJson);
		
		if (tableRequestDto.getMultiselection().getSelectedIds()!=null){
			List< TableRowDto< InspeccionesJson>> reorderSelection = this.inspeccionesJsonDao.reorderSelection(filterInspeccionesJson, tableRequestDto, startsWith);
			usuarioDto.setReorderedSelection(reorderSelection);
			usuarioDto.addAdditionalParam("reorderedSelection", reorderSelection);
			usuarioDto.addAdditionalParam("selectedAll", tableRequestDto.getMultiselection().getSelectedAll());
		}
		if (tableRequestDto.getSeeker().getSelectedIds()!=null){
			tableRequestDto.setMultiselection(tableRequestDto.getSeeker());
			List< TableRowDto< InspeccionesJson>> reorderSeeker = this.inspeccionesJsonDao.reorderSelection(filterInspeccionesJson, tableRequestDto, startsWith);
			usuarioDto.setReorderedSeeker(reorderSeeker);
			usuarioDto.addAdditionalParam("reorderedSeeker", reorderSeeker);
		}
		return usuarioDto;   
	}
    /**
	 * Searches rows in the InspeccionesJson table.
	 *
	 * @param filterInspeccionesJson InspeccionesJson
	 * @param searchInspeccionesJson InspeccionesJson
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<InspeccionesJson>>
	 */	
    public List< TableRowDto< InspeccionesJson>> search(InspeccionesJson filterInspeccionesJson, InspeccionesJson searchInspeccionesJson, TableRequestDto tableRequestDto, Boolean startsWith){
		return this.inspeccionesJsonDao.search(filterInspeccionesJson, searchInspeccionesJson, tableRequestDto, startsWith);
	}
    
    /**
	 * Reorder the selection made in InspeccionesJson table.
	 *
	 * @param filterInspeccionesJson InspeccionesJson
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith Boolean
	 * @return Object
	 */	
    public Object reorderSelection(InspeccionesJson filterInspeccionesJson, TableRequestDto tableRequestDto, Boolean startsWith){
		return this.inspeccionesJsonDao.reorderSelection(filterInspeccionesJson, tableRequestDto, startsWith);
	}
    
    /*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */
	 
	/**
	 * Finder method in the hierarchical the InspeccionesJson table.
	 *
	 * @param filterInspeccionesJson InspeccionesJson
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith Boolean
	 * @return TableResponseDto<JerarquiaDto<InspeccionesJson>>
	 */	
	public TableResponseDto<JerarquiaDto<InspeccionesJson>> jerarquia(InspeccionesJson filterInspeccionesJson, TableRequestDto tableRequestDto, Boolean startsWith){
		List<JerarquiaDto<InspeccionesJson>> listaInspeccionesJson =  this.inspeccionesJsonDao.findAllLikeJerarquia(filterInspeccionesJson, tableRequestDto);
		Long recordNum = this.inspeccionesJsonDao.findAllLikeCountJerarquia(filterInspeccionesJson, tableRequestDto);
		return new TableResponseDto<JerarquiaDto<InspeccionesJson>>(tableRequestDto, recordNum, listaInspeccionesJson);
	}
	
	/**
	 * Finder method for siblings rows in the hierarchical the InspeccionesJson table.
	 *
	 * @param filterInspeccionesJson InspeccionesJson
	 * @param tableRequestDto TableRequestDto
	 * @return TableResponseDto<JerarquiaDto<InspeccionesJson>>
	 */	
	public TableResponseDto<JerarquiaDto<InspeccionesJson>> jerarquiaChildren(InspeccionesJson filterInspeccionesJson, TableRequestDto tableRequestDto){
		TableResponseDto<JerarquiaDto<InspeccionesJson>> tableResponseDto = new TableResponseDto<JerarquiaDto<InspeccionesJson>>();
		tableResponseDto.addAdditionalParam(TableResponseDto.CHILDREN, this.inspeccionesJsonDao.findAllChild(filterInspeccionesJson, tableRequestDto));
		return tableResponseDto;
	}
	
	/**
    * Exporta Datos al clipBoard
    *
    */
    public List<InspeccionesJson> getMultiple(InspeccionesJson filterInspeccionesJson, TableRequestDto tableRequestDto,  Boolean startsWith){
		return this.inspeccionesJsonDao.getMultiple(filterInspeccionesJson, tableRequestDto, startsWith);
	}
      
	
	
}

